﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.ui.*;
	import Wall;
	import Util;
	
	public class BallLauncher extends Obstacle
	{
		/*
		/	The walls that surround three sides of the launcher.
		*/
		var wall1:Wall;
		var wall2:Wall;
		var wall3:Wall;
		
		/*
		/	True if the ball was just launched, false otherwise.
		*/
		public var launched:Boolean;
		
		/*
		/	Constructor function for a BallLauncher.
		*/
		public function BallLauncher()
		{
			selector.graphics.drawRect(0, 0, Util.gridUnit, Util.gridUnit);
			launched = false;
		}
			
		//prototypes	
		public override function updateWalls() {}
		public function launchBall() {}
		public override function rotateLeft() {}
		public override function rotateRight() {}
		
		/*
		/	Function used to handle launching the ball by pressing space.
		*/
		public override function keyboard_handler(e:KeyboardEvent):void
		{
			super.keyboard_handler(e);
			
			if (e.keyCode == Keyboard.SPACE)
			{
				if (this.x <= Util.gridUnit * 18)
				{
					deselectAll();
					launchBall();
				}
			}
		}
		
		public override function mouseUp_handler(e:MouseEvent):void
		{
			super.mouseUp_handler(e);
			
			if (this.y < Util.gridUnit * 7 && this.x <= Util.gridUnit * 18)
				this.y = Util.gridUnit * 7;
		}
		
		/*
		/	Launches the ball when the 'Go' button is clicked.
		*/
		public function clickGo():void
		{
			if (this.x <= Util.gridUnit * 18)
			{
				deselectAll();
				launchBall();
			}
		}
		
		/*
		/Deselects all objects when the ball is launched
		*/
		public function deselectAll()
		{
			var i = parent.numChildren;
			
			while (i--)
			{
				if (parent.getChildAt(i) is Obstacle)
				{
					var obs = parent.getChildAt(i) as Obstacle;
					
					if (obs.isSelected)
						obs.isSelected = false;
				}
			}
		}
		/*
		Check to see if it's okay to launch the ball
		*/
		public function legalLaunch():Boolean
		{
			var i = parent.numChildren;
			
			while (i--)
			{
				//is a bowling ball out there?
				if (parent.getChildAt(i) is BowlingBall)
					return false;
				//are any obstacles being dragged?
				if (parent.getChildAt(i) is Obstacle)
				{
					var obs = parent.getChildAt(i) as Obstacle;
					
					if (obs.isDragging)
						return false;
				}
				else if (parent.getChildAt(i) is TryAgain)
					return false;
			}
			
			return true;
		}
		
		/*
		/	Removes the walls around the launcher.
		*/
		public override function removeWalls()
		{
			parent.removeChild(wall1);
			parent.removeChild(wall2);
			parent.removeChild(wall3);
		}
	}
}