﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Point;
	import flash.text.*;
	import Util;
	import Wall;
	import HalfPipeNW;
	
	public class BowlingBall extends MovieClip
	{
		public var vx:Number = Util.moveUnit;
		public var vy:Number = 0;
		public var lastvx:Number;
		public var lastvy:Number;
		public var inAir:Boolean = false;
		public var bigRamp:Boolean = false;
		//The direction of the launching ramp
		//1 = N, 2 = E, 3 = S, and 4 = W
		public var rampDir:Number = 0;
		public var hitObject:Boolean = false;
		public var xDown:Number = -1;
		public var yDown:Number = -1;
		public var framesLeftInAir:Number = 0;
		public var art:MovieClip;
		public var numPieces:int = 0;
		//1 = N, 2 = E, 3 = S, and 4 = W
		public var approach:int = 0;
		public var origWidth;
		public var origHeight;
		
		public function BowlingBall()
		{
			art = new BowlingBallArt();
			art.x = this.x;
			art.y = this.y;
			
			name = "BowlingBall";
			
			this.addEventListener(Event.ENTER_FRAME, enterFrame_handler);
			this.addEventListener(Event.ADDED_TO_STAGE, added_handler_ball);
			
			this.visible = false;
		}
		
		public function added_handler_ball(e:Event)
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, added_handler_ball);
			parent.setChildIndex(this,1);
			art.x = this.x;
			art.y = this.y;
			parent.addChild(art);
			parent.setChildIndex(art, 2);
			art.scaleX = 1;
			art.scaleY = 1;
		}
		
		public function die()
		{
			
			//trace("die");
			/*var ta:MovieClip = new TryAgain();
				
			//Set positions. the -15's are to accomodate for the level position
			ta.y = 200 - (ta.height/2) - 15;
			
			parent.addChild(ta);
			ta.play();
			
			var level:Level = parent as Level;
			
			if (level != null)
			{
				var goalx = level.Goal.x;
			
				if (this.x == goalx + 30 || this.x == goalx - 30)
				{
					var almost = new Almost();
					
					//Set positions. the -15's are to accomodate for the level position
					almost.x = 350 - (almost.width/2) - 15;
					almost.y = 100;
					
					parent.addChild(almost);
					almost.play();
					
				}
				
			}*/
				
			if (this.parent != null)
			{
				var i = parent.numChildren;
				
				while (i--)
				{
					var obj = parent.getChildAt(i);
					
					if (obj is Obstacle)
					{
						(obj as Obstacle).used = false;
					}
				}
				
				this.removeEventListener(Event.ENTER_FRAME, enterFrame_handler);
				this.parent.removeChild(art);
				this.parent.removeChild(this);
			}
		}
		
		private function enterFrame_handler(e:Event)
		{
			if (this.parent == null || art.parent == null)
				return;
				
			this.x += vx;
			this.y += vy;
			art.x += vx;
			art.y += vy;
			
			//up = 1;
			//left = 6;
			//dn = 11;
			//right = 16;
			
			if (lastvx != vx && vx > 0)
				art.gotoAndPlay(16);
			else if (lastvx != vx && vx < 0)
				art.gotoAndPlay(6);
			else if (lastvy != vy && vy > 0)
				art.gotoAndPlay(11);
			else if (lastvy != vy && vy < 0)
				art.gotoAndPlay(1);
				
			
			lastvx = vx;
			lastvy = vy;
						
			var i:int = parent.numChildren;
			while(i--)
			{				
				var obj = parent.getChildAt(i);
				
				if (obj.parent == null)
					continue;
				
				if (inAir)
				{					
					if (this.hitTestObject(obj))
					{
						if (obj is Bumper || obj is HalfPipe || obj is FullPipe || obj is BallLauncher)
						{
							if (this.vx > 0)
							{
								if (obj.x >= this.xDown && this.x > this.xDown - (Util.gridUnit))
								{
									die(); i = 0; break;
								}
							}
							else if (this.vx < 0)
							{
								if (obj.x <= this.xDown && this.x < this.xDown + (Util.gridUnit))
								{
									die(); i = 0; break;
								}								
							}
							else if (this.vy > 0)
							{
								if (obj.y >= this.yDown && this.y > this.yDown - (Util.gridUnit))
								{
									die(); i = 0; break;
								}								
							}
							else if (this.vy < 0)
							{
								if (obj.y <= this.yDown && this.y < this.yDown + (Util.gridUnit))
								{
									die(); i = 0; break;
								}								
							}
						}
					}
					
					//scaling
					if (bigRamp)
					{
						if (this.vx == 0)
						{
							if (this.vy < 0 && (this.y - 30) > yDown && art.width < 40  && (this.y - 105) <= yDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vy < 0 && (this.y - 20) <= yDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
							
							if (this.vy > 0 && (this.y + 30) < yDown && art.width < 40  && (this.y + 105) >= yDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vy > 0 && (this.y + 20) <= yDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
						}
						else if (this.vy == 0)
						{
							if (this.vx < 0 && (this.x - 30) > xDown && art.width < 40  && (this.x - 105) <= xDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vx < 0 && (this.x - 20) <= xDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
							
							if (this.vx > 0 && (this.x + 30) < xDown && art.width < 40  && (this.x + 105) <= xDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vx > 0 && (this.x + 20) >= xDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
						}
					}
					else
					{
						if (this.vx == 0)
						{
							if (this.vy < 0 && (this.y - 30) > yDown && art.width < 40  && (this.y - 50) <= yDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vy < 0 && (this.y - 15) <= yDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
							
							if (this.vy > 0 && (this.y + 30) < yDown && art.width < 40  && (this.y + 50) >= yDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vy > 0 && (this.y + 15) <= yDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
						}
						else if (this.vy == 0)
						{
							if (this.vx < 0 && (this.x - 30) > xDown && art.width < 40  && (this.x - 50) <= xDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vx < 0 && (this.x - 15) <= xDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
							
							if (this.vx > 0 && (this.x + 30) < xDown && art.width < 40  && (this.x + 50) <= xDown)
							{
								art.width += 1;
								art.height += 1;
								art.x -= .5;
								art.y -= .5;
							}
							else if ( art.width > 30  && this.vx > 0 && (this.x + 15) >= xDown)
							{
								art.width -= 1;
								art.height -= 1;
								art.x += .5;
								art.y += .5;
							}
						}
					}

					if (this.x == this.xDown && this.y == this.yDown)
					{
						if (bigRamp)
						{
							var objects = parent.getObjectsUnderPoint(new Point(this.xDown+Util.gridUnit, this.yDown+Util.gridUnit))
							var k = objects.length;
							var hasLanded = false;
							
							while (k--)
							{
								if (objects[k].parent != null)
								{
									if (objects[k].parent is BigRamp)
									{
										if (rampDir == 1 && objects[k].parent is BigRampS)
											hasLanded = true;
										else if (rampDir == 2 && objects[k].parent is BigRampW)
											hasLanded = true;
										else if (rampDir == 3 && objects[k].parent is BigRampN)
											hasLanded = true;
										else if (rampDir == 4 && objects[k].parent is BigRampE)
											hasLanded = true;
									}
								}
							}
							
							if (!hasLanded)
							{
								var hole = new Explosion();
								hole.x = this.x;
								hole.y = this.y;
								
								if (this.x > 0 && this.x < Util.gridUnit * 19 && this.y > 0 && this.y < Util.gridUnit * 12)
								{
									if (!((this.y == 7 * Util.gridUnit || this.y == 8 * Util.gridUnit) && (this.x == 3 * Util.gridUnit || this.x == 7 * Util.gridUnit || this.x == 11 * Util.gridUnit || this.x == 15 * Util.gridUnit)))
										parent.addChild(hole);
								}
								
								die(); break;
							}
						}
						
						inAir = false;
						bigRamp = false;
						xDown = -1;
						yDown = -1;
					}
					else
						continue;
				}
				//REINSERT THE LOADS OF CODE HERE
				
				if (obj is Catcher || obj is SmallRamp || obj is BigRamp || obj is Bumper)
				{
					if (obj.parent.getChildIndex(obj) > art.parent.getChildIndex(art))
						parent.swapChildren(obj, art);
				}
				else
				{
					if (obj.parent.getChildIndex(obj) < art.parent.getChildIndex(art))
						parent.swapChildren(obj,art);
				}
						
				
				if (this.hitTestObject(obj))
				{
					if (obj is Obstacle && obj.parent != null)
					{
						var obs = obj as Obstacle;
						obs.collide(this);
						
						if (obj is WinZone || obj is KillZone)
							break;
					}
				}
			}
			
		}
	}
}