﻿package
{
	import flash.display.*;
	import flash.events.*;
	import Util;
	import Wall;
	
	public class Bumper extends Obstacle
	{
		var wall1:Wall;
		var wall2:Wall;
		var wall3:Wall;
		var wall4:Wall;
		
		public function Bumper()
		{
			//Util.snap(this)
			//updateWalls();
			selector.graphics.drawRect(0, 0, Util.gridUnit, Util.gridUnit);
		}
		
		public override function collide(b:BowlingBall)
		{
			//if ball is coming from the north
			if (b.x == this.x && b.y < this.y && b.vy > 0)
				b.vy *= -1;
				
			//if ball is coming from the west
			else if (b.x < this.x && b.y == this.y && b.vx > 0)
				b.vx *= -1;
				
			//if ball is coming from the south
			else if (b.x == this.x && b.y > this.y && b.vy < 0)
				b.vy *= -1;
				
			//if ball is coming in from the east
			else if (this.x < b.x && this.y == b.y && b.vx < 0)
				b.vx *= -1;
				
			if (buttonMode && !used)
			{
				used = true;
				b.numPieces++;
			}
		}
		
		public override function updateWalls()
		{
			wall1 = Util.createWall(this, this.x, this.y, 1);
			wall2 = Util.createWall(this, this.x, this.y, 2);
			wall3 = Util.createWall(this, this.x, this.y, 3);
			wall4 = Util.createWall(this, this.x, this.y, 4);
		}
		
		public override function removeWalls()
		{
			parent.removeChild(wall1);
			parent.removeChild(wall2);
			parent.removeChild(wall3);
			parent.removeChild(wall4);
		}
		
		public override function added_Handler(e:Event):void
		{
			super.added_Handler(e);
			this.removeEventListener(Event.ADDED_TO_STAGE, added_Handler);
			parent.setChildIndex(this, 0);
		}
	}
}