﻿package
{
	import flash.display.*;
	import flash.events.*;
	import Util;
	import Wall;
	
	public class HalfPipeNE extends HalfPipe
	{
		var wall1:Wall;
		var wall2:Wall;
		
		public function HalfPipeNE()
		{

		}
		
		public override function collide(b:BowlingBall)
		{
			//if ball is coming from the south
			if (b.x == this.x && b.y > this.y && b.vy < 0)
				b.vy *= -1;
				
			//if ball is coming from the west
			else if (b.x < this.x && b.y == this.y && b.vx > 0)
				b.vx *= -1;
			
			//Otherwise, wait until it hits the pipe
			else if (this.x == b.x && this.y == b.y)
				switchPipe(b);
			
			if (buttonMode && !used)
			{
				b.numPieces++;
				used = true;
			}
		}
		
		public override function updateWalls()
		{
			wall1 = Util.createWall(this, this.x, this.y, 4);
			wall2 = Util.createWall(this, this.x, this.y, 3);
		}
		
		public override function removeWalls()
		{
			parent.removeChild(wall1);
			parent.removeChild(wall2);
		}
		
		public override function switchPipe(b:BowlingBall)
		{
			//coming in from east
			if (b.vx < 0)
			{
				b.vx = 0;
				b.vy = Util.moveUnit * -1;
			}
			else //coming from north
			{
				b.vy = 0;
				b.vx = Util.moveUnit;
			}
		}
		
		public override function rotateRight()
		{
			var HPSE:HalfPipeSE = new HalfPipeSE();
			HPSE.x = this.x;
			HPSE.y = this.y;
			HPSE.isSelected = true;
			parent.addChild(HPSE);
			HPSE.setDraggable(true);
			stage.focus = HPSE;
			
			//this.removeWalls();
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			this.parent.removeChild(this);
		}
		
		public override function rotateLeft()
		{
			var HPNW:HalfPipeNW = new HalfPipeNW();
			HPNW.x = this.x;
			HPNW.y = this.y;
			HPNW.isSelected = true;
			parent.addChild(HPNW);
			HPNW.setDraggable(true);
			stage.focus = HPNW;
			
			//this.removeWalls();
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			this.parent.removeChild(this);
		}
	}
}