﻿package
{
	import flash.display.*;
	import flash.events.*;
	import Util;
	import Wall;
	
	public class HalfPipeNW extends HalfPipe
	{
		var wall1:Wall;
		var wall2:Wall;
		
		public function HalfPipeNW()
		{

		}
		
		public override function collide(b:BowlingBall)
		{
			//if ball is coming from the south
			if (b.x == this.x && b.y > this.y && b.vy < 0)
				b.vy *= -1;
				
			//if ball is coming from the east
			else if (b.x > this.x && b.y == this.y && b.vx < 0)
				b.vx *= -1;
			
			//Otherwise, wait until it hits the pipe
			else if (this.x == b.x && this.y == b.y)
				switchPipe(b);
			
			if (buttonMode && !used)
			{
				b.numPieces++;
				used = true;
			}
		}
		
		public override function updateWalls()
		{
			wall1 = Util.createWall(this, this.x, this.y, 2);
			wall2 = Util.createWall(this, this.x, this.y, 3);
		}
		
		public override function removeWalls()
		{
			parent.removeChild(wall1);
			parent.removeChild(wall2);
		}
		
		public override function switchPipe(b:BowlingBall)
		{
			//coming in from west
			if (b.vx > 0)
			{
				b.vx = 0;
				b.vy = Util.moveUnit * -1;
			}
			else //coming from north
			{
				b.vy = 0;
				b.vx = Util.moveUnit * -1;
			}
		}
		
		public override function rotateRight()
		{
			var HPNE:HalfPipeNE = new HalfPipeNE();
			HPNE.x = this.x;
			HPNE.y = this.y;
			HPNE.isSelected = true;
			parent.addChild(HPNE);
			HPNE.setDraggable(true);
			stage.focus = HPNE;
			
			//this.removeWalls();
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			this.parent.removeChild(this);
		}
		
		public override function rotateLeft()
		{
			var HPSW:HalfPipeSW = new HalfPipeSW();
			HPSW.x = this.x;
			HPSW.y = this.y;
			HPSW.isSelected = true;
			parent.addChild(HPSW);
			HPSW.setDraggable(true);
			stage.focus = HPSW;
			
			//this.removeWalls();
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			this.parent.removeChild(this);
		}
	}
}