﻿package
{
	import flash.display.*;
	import flash.events.*;
	import Util;
	import Wall;
	
	public class HalfPipeSE extends HalfPipe
	{
		var wall1:Wall;
		var wall2:Wall;
		
		public function HalfPipeSE()
		{
			
		}
		
		public override function collide(b:BowlingBall)
		{
			//if ball is coming from the north
			if (b.x == this.x && b.y < this.y && b.vy > 0)
				b.vy *= -1;
				
			//if ball is coming from the west
			else if (b.x < this.x && b.y == this.y && b.vx > 0)
				b.vx *= -1;
			
			//Otherwise, wait until it hits the pipe
			else if (this.x == b.x && this.y == b.y)
				switchPipe(b);
			
			if (buttonMode && !used)
			{
				b.numPieces++;
				used = true;
			}
		}
		
		public override function updateWalls()
		{
			wall1 = Util.createWall(this, this.x, this.y,  1);
			wall2 = Util.createWall(this, this.x, this.y,  4);
		}
		
		public override function removeWalls()
		{
			parent.removeChild(wall1);
			parent.removeChild(wall2);
		}
		
		public override function switchPipe(b:BowlingBall)
		{
			//coming in from east
			if (b.vx < 0)
			{
				b.vx = 0;
				b.vy = Util.moveUnit;
			}
			else 
			{
				b.vy = 0;
				b.vx = Util.moveUnit;
			}
		}
		
		public override function rotateLeft()
		{
			//stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			
			var HPNE:HalfPipeNE = new HalfPipeNE();
			HPNE.x = this.x;
			HPNE.y = this.y;
			parent.addChild(HPNE);
			HPNE.setDraggable(true);
			HPNE.isSelected = true;
			stage.focus = HPNE;
			
			trace(HPNE.isSelected);
			
			//this.removeWalls();
			this.parent.removeChild(this);
		}
		
		public override function rotateRight()
		{
			//stage.removeEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			
			var HPSW:HalfPipeSW = new HalfPipeSW();
			HPSW.x = this.x;
			HPSW.y = this.y;
			parent.addChild(HPSW);
			HPSW.setDraggable(true);
			HPSW.isSelected = true;
			stage.focus = HPSW;
			
			//this.removeWalls();
			this.parent.removeChild(this);
		}
	}
}