﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	
	public class Obstacle extends MovieClip
	{
		var isSelected:Boolean;
		var selector:MovieClip;
		var isDragging:Boolean = false;
		var playerObjMarker:MovieClip;
		var used:Boolean = false;
		
		var prevX = -1;
		var prevY = -1;
		
		public function Obstacle()
		{	
			this.doubleClickEnabled = true;
			
			isSelected = false;
			
			selector = new MovieClip();
			selector.graphics.lineStyle(3, 0xffff00);
			selector.name = "selectorObject";
			selector.buttonMode = true;
			selector.tabEnabled = false;
			this.tabEnabled = false;
			
			playerObjMarker = new MovieClip();
			playerObjMarker.name = "playerObject";
			playerObjMarker.graphics.beginFill(0xffff00);
			playerObjMarker.graphics.lineStyle(1, 0x000000);
			playerObjMarker.graphics.drawCircle(15, 15, 3);
			playerObjMarker.buttonMode = true;
			playerObjMarker.tabEnabled = false;
			
			this.buttonMode = false;
			
			Util.snap(this)
			
			
			this.addEventListener(Event.ADDED_TO_STAGE, added_Handler);
			
			/*
			this.addEventListener(MouseEvent.DOUBLE_CLICK, mouseDoubleClick_handler);
			this.addEventListener(Event.ENTER_FRAME, enterFrame_handler);
			this.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown_handler);
			this.addEventListener(MouseEvent.MOUSE_UP, mouseUp_handler);
			*/
		}
		
		public function setDraggable(a:Boolean)
		{
			
			if (!a)
			{
				isSelected = false;
				if (this.hasEventListener(MouseEvent.DOUBLE_CLICK))
					this.removeEventListener(MouseEvent.DOUBLE_CLICK, mouseDoubleClick_handler);
				if (this.hasEventListener(MouseEvent.MOUSE_UP))
					this.removeEventListener(MouseEvent.MOUSE_UP, mouseUp_handler);
				if (this.hasEventListener(MouseEvent.MOUSE_DOWN))
					this.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDown_handler);
				if (this.hasEventListener(Event.ENTER_FRAME))
					this.removeEventListener(Event.ENTER_FRAME, enterFrame_handler);
			}
			else
			{
				if (!this.hasEventListener(MouseEvent.DOUBLE_CLICK))
					this.addEventListener(MouseEvent.DOUBLE_CLICK, mouseDoubleClick_handler);
				if (!this.hasEventListener(MouseEvent.MOUSE_UP))
					this.addEventListener(MouseEvent.MOUSE_UP, mouseUp_handler);
				if (!this.hasEventListener(MouseEvent.MOUSE_DOWN))
					this.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown_handler);
				if (!this.hasEventListener(Event.ENTER_FRAME))
					this.addEventListener(Event.ENTER_FRAME, enterFrame_handler);
				
				this.addChild(playerObjMarker);
				
				this.buttonMode = true;
			}
		}
		
		public function removeWalls() {}
		
		public function mouseDown_handler(e:MouseEvent):void 
		{
			if (!ballInPlay())
			{
				if (e.target is Obstacle)
				{
					isDragging = true;
					//removeWalls();
					prevX = this.x;
					prevY = this.y;
					e.target.startDrag();
					e.target.parent.setChildIndex(e.target, e.target.parent.numChildren - 1);
				}
				else if (e.target.name == "playerObject" || e.target.name == "selectorObject")
				{
					e.target.parent.isDragging = true;
					//e.target.parent.removeWalls();
					e.target.parent.prevX = e.target.parent.x;
					e.target.parent.prevY = e.target.parent.y;
					e.target.parent.startDrag();
					e.target.parent.setChildIndex(e.target, e.target.parent.numChildren - 1); 
				}
			}
			
		}
		
		public function ballInPlay():Boolean
		{
			var i = parent.numChildren;
			
			while (i--)
			{
				if (parent.getChildAt(i) is BowlingBall)
					return true;
			}
			
			return false;
		}
		
		public function mouseUp_handler(e:MouseEvent):void 
		{
			e.target.stopDrag();
			
			var i = parent.numChildren;
			
			Util.snap(this);
			//updateWalls();
			
			while (i--)
			{
				var curr = parent.getChildAt(i);
				
				/*
				if (curr is Obstacle)
				{
					if (curr.isDragging && curr.name != this.name)
					{
						curr.stopDrag();
						Util.snap(curr);
						if (curr.prevX != -1)
							curr.x = curr.prevX;
						if (curr.prevY != -1)
							curr.y = curr.prevY;
						curr.isDragging = false;
					}
				}*/
			}
		
			if (!isSelected && selector.parent == null && !ballInPlay())
			{
				deselectAllObs();
				this.addChild(selector);
				isSelected = true;
			}
			else if (this.x == prevX && this.y == prevY)
			{
				if (selector.parent != null)
					this.removeChild(selector);
				isSelected = false;
			}
			
			if (this.x == Util.gridUnit * 19)
				this.x = Util.gridUnit * 18;
			if (this.x > Util.gridUnit * 22 || this.x < 0)
				this.x = prevX;
				
			if (this.y  > Util.gridUnit * 11)
				this.y = Util.gridUnit * 11;
			if (this.y < 0)
				this.y = prevY;
				
			var j = parent.numChildren;
			
			//dont let objects overlap
			while (j--)
			{
				var obj = parent.getChildAt(j);
				
				if (obj.name != this.name && obj.x == this.x && obj.y == this.y)
				{
					this.x = prevX;
					this.y = prevY;
				}
			}
			
			isDragging = false;
		}
		
		public function deselectAllObs()
		{
			var i = parent.numChildren;
			
			while (i--)
			{
				var obj = parent.getChildAt(i);
				
				if (obj is Obstacle)
				{
					var obs = obj as Obstacle;
					
					obs.isSelected = false;
				}
			}
		}
			
		public function enterFrame_handler(e:Event):void
		{
			//if (!ballInPlay())
			//{
				if (this.parent != null)
				{
					if (isSelected && selector.parent == null)
						this.addChild(selector);
					else if (!isSelected && selector.parent != null)
						this.removeChild(selector);
				}
			//}
			
			if (!isDragging)
			{
				if (this.x >= Util.gridUnit * 20)
				{
					if(this.y < 11) {
						//trace("top");
						this.x = prevX;
						this.y = prevY;
					}
					
					if (this.y < 46) {
						this.y= 11;
					} else if (this.y < 81) {
						this.y= 46;
					} else if (this.y < 116) {
						this.y= 81;
					} else if (this.y < 151) {
						this.y= 116;
					} else if (this.y < 186) {
						this.y= 151;
					} else if (this.y < 221) {
						this.y= 186;
					} else if (this.y < 256) {
						this.y= 221;
					}
					
					if (this.x < 640)
						this.x= 600;
					else if (this.x >= 645)
						this.x= 645;
						
					if (this.y >= 256) {
						x = prevX;
						y = prevY;
					}
				}
						
					
			}
		}
		
		public function added_Handler(e:Event):void
		{
			//trace("added!"+this.name);
			this.removeEventListener(Event.ADDED_TO_STAGE,added_Handler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyboard_handler);
			parent.setChildIndex(this, numChildren-1);
			//updateWalls();
		}
		
		public function updateWalls(){}
		
		public function keyboard_handler(e:KeyboardEvent):void
		{
			if (!ballInPlay())
			{
			//trace("keyboardFor!"+this.name);
				if (selector.parent != null)
				{
					if (e.keyCode == Keyboard.LEFT)
					{
						if (this.parent != null && !ballInPlay())
							rotateLeft();
					} 
					else if (e.keyCode == Keyboard.RIGHT)
					{
						if (this.parent != null && !ballInPlay())
							rotateRight();
					}
				}
			}
		}
		
		public function rotateLeft(){}
		public function rotateRight(){}
		public function collide(b:BowlingBall){}
		
		public function mouseDoubleClick_handler(e:Event):void
		{

		}
	}
}