﻿/*
This class controls player thrown snow balls from the Tray of Judgement
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.media.*;
	
	public class Judgement extends Killable
	{		
		public var impact:Impact = new Impact();
		public var impactChannel:SoundChannel = new SoundChannel();
		
		public var speedX:int;
		public var speedY:int;
		
		public var flyTime:int;
		public var crashed:Boolean;
		
		public function Judgement(x_, y_, tarX, tarY)
		{	
			main = this;
			
			x = x_;
			y = y_;
			
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
			
			var targetX:int = tarX;
			var targetY:int = tarY;
			
			var dx:int;
			var dy:int;
			var dz:int;
			var fx:Number;
			var fy:Number;
			var rand:Number = Math.random()*2;
			if (Math.random() < .5)
				rand = rand * -1;
			
			dx = x - targetX;
			dy = y - targetY;
			dz = Math.sqrt(dx*dx + dy*dy)
			
			fx = (10*dx)/dz;
			fy = (10*dy)/dz;
			
			speedX = fx + rand;
			speedY = fy + rand;
			
			flyTime = 25 + Math.random() * 10;
			crashed = false;
		}
		
		public function added(e:Event)
		{
			
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{
				flyTime--;
				
				var i:int = parent.numChildren;

				while(i--)
				{
					var obj:DisplayObject = parent.getChildAt(i);
					if(this.hitTestObject(obj))
					{
						var that;
						
						if ((obj is TreeCollider) || (obj is SlalomCollider))
						{
							crashed = true;
						}
						else if (obj is SledderCollider)
						{ 
							crashed = true;
														
							var l:int = parent.numChildren;
							while (l--)
							{
								var that3:DisplayObject = parent.getChildAt(l);
								if ((that3.x == obj.x) && (that3.y == obj.y) && (that3 is Sledder))
								{
									var thatSledder = that3 as Sledder;
									if (thatSledder.crashTime <= 0) thatSledder.hit();
								}
							}
						}
						else if ((obj is SnowManCollider) || (obj is SnowBall))
						{ 
							crashed = true;
							if ((obj is SnowManCollider) && !(Game.main.muted)) impactChannel = impact.play();
							
							if (obj is SnowManCollider)
							{
								var k:int = parent.numChildren;
								while (k--)
								{
									var that2:DisplayObject = parent.getChildAt(k);
									if ((that2.x == obj.x) && (that2.y == obj.y) && (that2 is SnowMan))
									{
										var thatSnowMan = that2 as SnowMan;
										thatSnowMan.hit();
									}
								}
							}
						}
					}
				}
				
				move();
				
				if (flyTime <= 0 || crashed)
				{
					if (this.parent != null)
					{
						if (!Game.main.muted) impactChannel = impact.play();
						var explode = new SnowBallExplode();
						parent.addChild(explode);
						explode.x = this.x;
						explode.y = this.y;
						kill();
					}
				}
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
		
		public function move()
		{
			if (this.parent != null)
			{
				y -= speedY;
				x -= speedX;

				if (y < -10 || y > Game.HEIGHT + 10 || x < -10 || x > Game.WIDTH + 10)
				{
					kill();
				}
			}
		}
	}
}