﻿/*
This class controls trees
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	
	public class Plant extends Killable
	{
		public var dead:Boolean;
		
		public var collider;
		
		//the tree is created in the Game's initGame() function 
		public function Plant(x_, y_)
		{
			//set the position of the tree
			x = x_;
			y = y_;
			
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
		}
		
		public function added(e:Event)
		{
			collider = new TreeCollider();
			collider.x = x;
			collider.y = y;
			collider.visible = false;
			parent.addChild(collider);
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{
				move();
				
				if (y < -40)
				{
					kill();
				}
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				if (collider.parent != null) parent.removeChild(collider);
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
		
		//called when the player hits this
		public function hit()
		{
			
		}
		
		//at frame rate see if any of the arrows keys are being pressed
		public function move()
		{
			if (this.parent != null)
			{
				if (Game.main.player.moving)
				{
					y -= 10;
					if (collider.parent != null) collider.y -= 10;
				}
			}
		}
	}
}