﻿/*
This class controls the player character
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.media.*;

	public class Player extends Killable
	{
		var cheer:Cheer = new Cheer();
		var cheerChannel:SoundChannel = new SoundChannel();
		var crash:Crash = new Crash();
		var crashChannel:SoundChannel = new SoundChannel();
	
		//the player's movement speed
		public var vir:Number = 0;
		public var hor:Number = 0;
		//buffers to keep player from moving too far off screen
		public var xBuffer:int;
		public var yBuffer:int;
		
		//weather or not the player is moving
		public var moving:Boolean;
		
		//weather or not the player is invincible
		public var invincible:Boolean;
		
		//times a stop
		public var hitime:int;
		public var hitMax:int;
		
		//Tray of Stealth active?
		public var stealth:Boolean = false;
		public var stealthCount:int = 0;
		
		//Tray of Doom active?
		public var doom:Boolean = false;
		public var doomCount:int = 0;
		
		//Tray of Time Warp active?
		public var timeWarp:Boolean = false;
		public var timeWarpCount:int = 0;
		
		//Tray of Judgement active?
		public var judge:Boolean = false;
		public var judgeCount:int = 0;
		
		//is the game over?
		public var endIt:Boolean = false;
		
		//the player is created in the Game's initGame() function 
		public function Player(x_, y_)
		{	
			xBuffer = 30;
			yBuffer = 30;
			
			//set the position of the player
			x = x_;
			y = y_;
			
			moving = true;
			invincible = false;

			//decide on a speed for player movement
			vir = 0;
			hor = 0;
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
		}
		
		public function added(e:Event)
		{
						
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			gotoAndPlay(3);
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((!Game.frozen) && (this.parent != null))
			{
				var i:int = parent.numChildren;
													
				var par;
				var thatSledder:Sledder;
				var thatPlant:Plant;
				var thatSnowMan:SnowMan;
				var thatPowerUp:PowerUp;
	
				while(i--)
					{					
						var obj:DisplayObject = parent.getChildAt(i);
						if(this.hitTestObject(obj))
						{
							if ((obj is Plant) || ((obj is SnowMan) && !(obj is SnowBall)))
							{
								parent.setChildIndex(this, parent.getChildIndex(obj) - 1);
							}
							else if (((obj is TreeCollider) || (obj is SlalomCollider)) && moving && !invincible)
							{
								crashChannel = crash.play();
								moving = false;
								invincible = true;
								hitime = 60;
								hitMax = 60;
								
								var j:int = parent.numChildren;
								while (j--)
								{
									var that:DisplayObject = parent.getChildAt(j);
									if ((that.x == obj.x) && (that.y == obj.y) && (that is Plant))
									{
										thatPlant = that as Plant;
										thatPlant.hit();
									}
								}
							}
							else if (((obj is SnowManCollider) || (obj is SnowBall)) && moving && !invincible)
							{
								moving = false;
								invincible = true;
								hitime = 30;
								hitMax = 30;
								
								var k:int = parent.numChildren;
								while (k--)
								{
									var that2:DisplayObject = parent.getChildAt(k);
									if ((that2.x == obj.x) && (that2.y == obj.y) && (that2 is SnowMan))
									{
										thatSnowMan = that2 as SnowMan;
										thatSnowMan.hit();
									}
								}
							}
							else if ((obj is SledderCollider) && moving && !invincible)
							{
								crashChannel = crash.play();
								that = obj as SledderCollider;
						
								var l:int = parent.numChildren;
								while (l--)
								{
									var that3:DisplayObject = parent.getChildAt(l);
									if ((that3.x == obj.x) && (that3.y == obj.y) && (that3 is Sledder))
									{
										thatSledder = that3 as Sledder;
										if (thatSledder.crashTime <= 0)
										{
											moving = false;
											invincible = true;
											hitime = 30;
											hitMax = 30;
											
											thatSledder.hit();
										}
									}
								}
							}
							else if (obj is PowerUp)
							{
								thatPowerUp = obj as PowerUp;
								thatPowerUp.hit();
							}
							else if (obj is FinishLine)
							{
								endIt = true;
							}
						}
						
						if (((this.y <= obj.y + 10) && (this.y >= obj.y - 10)) && (this.x <= obj.x) && (obj is SlalomL))
						{
							par = parent;
							thatPlant = obj as SlalomL;
							par.timeTraveled -= 10;
							thatPlant.hit();
						}
						
						if (((this.y <= obj.y + 10) && (this.y >= obj.y - 10)) && (this.x >= obj.x) && (obj is SlalomR))
						{
							par = parent;
							thatPlant = obj as SlalomR;
							par.timeTraveled -= 10;
							thatPlant.hit();
						}
					}
				
				if (invincible)
				{
					hitime -= 1;
				}
				
				if (hitime == hitMax/2)
				{
					moving = true;
				}
				
				if (hitime == 0)
				{
					invincible = false;
				}
				else if (moving && !stealth)
				{
					if ((hitime % 2) == 0)
					{
						this.visible = false;
					}
					else
					{
						this.visible = true;
					}
				}
				
				if (stealth)
				{
					this.alpha = 0.5;
					Game.main.stealthDisplay.alpha = 1;
					
					if ((stealthCount == 45) || (stealthCount == 43) || (stealthCount == 41)
						|| (stealthCount == 30) || (stealthCount == 28) || (stealthCount == 26)
						|| (stealthCount == 15) || (stealthCount == 13) || (stealthCount == 11)
						|| (stealthCount == 9) || (stealthCount == 7) || (stealthCount == 5)
						|| (stealthCount == 3) || (stealthCount == 1))
					{
						this.alpha = 1;
						Game.main.stealthDisplay.alpha = 0.5;
					}
					
					stealthCount--;
				}
				if (stealthCount <= 0)
				{
					stealth = false;
					this.alpha = 1;
					Game.main.stealthDisplay.alpha = 0.5;
				}
				
				if (doom)
				{
					Game.main.doomDisplay.alpha = 1;
					
					if ((doomCount == 45) || (doomCount == 43) || (doomCount == 41)
						|| (doomCount == 30) || (doomCount == 28) || (doomCount == 26)
						|| (doomCount == 15) || (doomCount == 13) || (doomCount == 11)
						|| (doomCount == 9) || (doomCount == 7) || (doomCount == 5)
						|| (doomCount == 3) || (doomCount == 1))
					{
						Game.main.doomDisplay.alpha = 0.5;
					}
					
					doomCount--;
				}
				if (doomCount <= 0)
				{
					doom = false;
					Game.main.doomDisplay.alpha = 0.5;
				}
				
				if (timeWarp)
				{
					Game.main.warpDisplay.alpha = 1;
					
					if ((timeWarpCount == 45) || (timeWarpCount == 43) || (timeWarpCount == 41)
						|| (timeWarpCount == 30) || (timeWarpCount == 28) || (timeWarpCount == 26)
						|| (timeWarpCount == 15) || (timeWarpCount == 13) || (timeWarpCount == 11)
						|| (timeWarpCount == 9) || (timeWarpCount == 7) || (timeWarpCount == 5)
						|| (timeWarpCount == 3) || (timeWarpCount == 1))
					{
						Game.main.warpDisplay.alpha = 0.5;
					}
					
					timeWarpCount--;
				}
				if (timeWarpCount <= 0)
				{
					timeWarp = false;
					Game.main.warpDisplay.alpha = 0.5;
				}
				
				if (judge)
				{
					Game.main.judgeDisplay.alpha = 1;
					
					if ((judgeCount == 45) || (judgeCount == 43) || (judgeCount == 41)
						|| (judgeCount == 30) || (judgeCount == 28) || (judgeCount == 26)
						|| (judgeCount == 15) || (judgeCount == 13) || (judgeCount == 11)
						|| (judgeCount == 9) || (judgeCount == 7) || (judgeCount == 5)
						|| (judgeCount == 3) || (judgeCount == 1))
					{
						Game.main.judgeDisplay.alpha = 0.5;
					}
					
					createJudgement();
					judgeCount--;
				}
				if (judgeCount <= 0)
				{
					judge = false;
					Game.main.judgeDisplay.alpha = 0.5;
				}
				
				if (moving)
				{
					move();
				}
				
				if (endIt)
				{
					cheerChannel = cheer.play();
					Game.quitCondition = 0;
					Game.main.quit();
				}
			}
		}
		
		public function createJudgement()
		{
			if ((judgeCount % 10) == 0)
			{
				var addJudgement;
				
				addJudgement = new Judgement(x, y, x + 10, y + 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x - 10, y + 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x - 10, y - 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x + 10, y - 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x, y + 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x, y - 10);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x - 10, y);
				Game.main.addChild(addJudgement);
				
				addJudgement = new Judgement(x, y, x + 10, y);
				Game.main.addChild(addJudgement);
			}
		}
		
		
		//at frame rate see if any of the arrows keys are being pressed
		public function move()
		{
			if(Key.isDown(Keyboard.LEFT) || Key.isDown(65))
			{
				hor -= 1.2;
				
				if (hor < -15)
				{
					hor = -15;
				}
				
				if ((hor > -8) && (hor < -2)) gotoAndPlay(2);
				else if (hor < -8) gotoAndPlay(1);
			}

			else if(Key.isDown(Keyboard.RIGHT) || Key.isDown(68))
			{ 
				hor += 1.2;
				
				if (hor > 15)
				{
					hor = 15;
				}
				
				if ((hor < 8) && (hor > 2)) gotoAndPlay(4);
				else if (hor > 8) gotoAndPlay(5);
			}
			else
			{
				if (hor > 2) gotoAndPlay(4);
				else if (hor < -2) gotoAndPlay(2);
				else gotoAndPlay(3);
			}
			
			if(Key.isDown(Keyboard.UP) || Key.isDown(87))
			{
				vir -= 0.8;
				
				if (vir < -8)
				{
					vir = -8;
				}
			}

			else if(Key.isDown(Keyboard.DOWN) || Key.isDown(83))
			{
				vir += 0.8;
				
				if (vir > 8)
				{
					vir = 8;
				}
			}
			
			if (vir > 0) vir -= 0.2;
			if (vir < 0) vir += 0.2;
			if (hor > 0) hor -= 0.2;
			if (hor < 0) hor += 0.2;
			if ((vir >= -0.2) && (vir <= 0.2)) vir = 0;
			if ((hor >= -0.2) && (hor <= 0.2)) hor = 0;
			
			if (x <= xBuffer)
			{
				if (hor < 0) hor = 0;
			}
			
			if (x >= Game.WIDTH-xBuffer)
			{
				if (hor > 0) hor = 0;
			}
			
			if (y <= yBuffer)
			{
				if (vir < 0) vir = 0;
			}
			
			if (y >= Game.HEIGHT-yBuffer)
			{
				if (vir > 0) vir = 0;
			}
			
			y += vir;
			var maxHor = hor;
			
			for (var j = 10 + vir; j > 0; j--)
			{
				var trail = new Trail(x, y + 20 - j);
				parent.addChild(trail);
				parent.setChildIndex(trail, 2);
				if (maxHor > 0)
				{
					x++;
					maxHor--;
				}
				else if (maxHor < 0)
				{
					x--;
					maxHor++;
				}
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
	}
}