﻿/*
This superclass controls powerups
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	
	public class PowerUp extends Killable
	{
		
		public var speed;
		
		//the powerup is created in the Game's placePowerUps() function 
		public function PowerUp(x_, y_)
		{	
			speed = (Math.random() * 3) + 2;
			
			//set the position of the tree
			x = x_;
			y = y_;
			
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
		}
		
		public function added(e:Event)
		{
			
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{				
				move();
				
				if (((y > 40 + Game.HEIGHT) && (Game.backwardsTrays))
					|| ((y < -40) && !(Game.backwardsTrays)))
				{
					kill();
				}
			}
		}
		
		//called when the player hits this
		public function hit()
		{
			if (this.parent != null)
			{
				var r:int = ((Math.random() * 4) + 1);
				var randomTray;
				if (r == 1)
				{
					randomTray = new TrayOfStealth(x,y);
				}
				else if (r == 2)
				{
					randomTray = new TrayOfTimeWarp(x,y);
				}
				else if (r == 3)
				{
					randomTray = new TrayOfDoom(x,y);
				}
				else if (r == 4)
				{
					randomTray = new TrayOfJudgement(x,y);
				}
				
				parent.addChild(randomTray);
				
				kill();
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
		
		//at frame rate see if any of the arrows keys are being pressed
		public function move()
		{
			if (this.parent != null)
			{
				if (Game.main.player.moving)
				{
					if (Game.backwardsTrays) y += speed;
					else y -= speed;
				}
				else
				{
					if (Game.backwardsTrays) y -= 10 - speed;
					else y += 10 - speed;
				}
			}
		}
	}
}