﻿/*
This class controls sledders
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	
	public class Sledder extends Killable
	{
		static public var main;
		
		public var speed;
		
		public var cooldown:int;
		public var crashed:Boolean;
		public var crashTime:int = 0;
		
		public var color:int;
		
		public var collider;
		
		//the sledder is created in the Game's PlaceSledders() function 
		public function Sledder(x_, y_)
		{	
			main = this;
			
			speed = (Math.random() * 4) + 3;
			color = (Math.random() * 3) + 1;
			
			if (color == 1) gotoAndPlay(1);
			else if (color == 2) gotoAndPlay(2);
			else if (color == 3) gotoAndPlay(3);
			
			//set the position of the sledder
			x = x_;
			y = y_;
			
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
			
			cooldown = 0;
			crashed = false;
		}
		
		public function added(e:Event)
		{
			collider = new SledderCollider();
			collider.x = x;
			collider.y = y;
			collider.visible = false;
			parent.addChild(collider);
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{
				var i:int = parent.numChildren;
				var that;

				while(i--)
				{					
					var obj:DisplayObject = parent.getChildAt(i);
					if(this.hitTestObject(obj))
					{
						if ((obj is Plant) || ((obj is SnowMan) && !(obj is SnowBall)))
						{
							parent.setChildIndex(this, parent.getChildIndex(obj) - 1);
						}
						
						if ((obj is TreeCollider) || (obj is SlalomCollider) || (obj is Judgement))
						{
							if (crashTime <= 0) hit();
						}
						else if (obj is SnowManCollider)
						{ 
							if (crashTime <= 0) 
							{
								hit();
								
								var k:int = parent.numChildren;
								while (k--)
								{
									var that2:DisplayObject = parent.getChildAt(k);
									if ((that2.x == obj.x) && (that2.y == obj.y) && (that2 is SnowMan))
									{
										var thatSnowMan = that2 as SnowMan;
										thatSnowMan.hit();
									}
								}
							}
						}
					}
				}
				
				if ((cooldown > 0) && !(Game.main.player.doom)) cooldown--;
				if ((crashTime > 0) && !(Game.main.player.doom)) crashTime--;
				
				if (!crashed)
				{
					var r:int = ((Math.random() * 200/Game.main.difficulty) + 1);
					if (y > 10 && y < Game.HEIGHT - 10 && r == 1 && cooldown == 0)
					{
						attack();
						cooldown = 60;
					}
				}
				
				if ((crashTime <= 30) && !(Game.main.player.doom))
				{
					crashed = false;
					if (this.currentFrame > 3)
					{
						gotoAndPlay(this.currentFrame - 3);
					}
					if ((crashTime % 2) == 0)
					{
						this.visible = true;
					}
					else
					{
						this.visible = false;
					}
				}
				
				move();
				
				if (y < -40)
				{
					kill();
				}
			}
		}
		
		//at frame rate see if any of the arrows keys are being pressed
		public function move()
		{
			if (this.parent != null)
			{
				if (Game.main.player.doom)
				{
					crashed = true;
					cooldown = 180;
					gotoAndPlay(this.currentFrame + 3);
				}

				if (Game.main.player.moving && !crashed)
				{
					y -= this.speed;
					if (collider.parent != null) collider.y -= this.speed;
				}
				else if (!Game.main.player.moving && !crashed)
				{
					y += 10 - this.speed;
					if (collider.parent != null) collider.y += 10 - this.speed;
				}
				else if (Game.main.player.moving && crashed)
				{
					y -= 10;
					if (collider.parent != null) collider.y -= 10;
				}
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				if (collider.parent != null) parent.removeChild(collider);
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
		
		//called when the player hits this
		public function hit()
		{
			crashed = true;
			crashTime = 45;
		}
		
		public function attack()
		{
			if (this.parent != null)
			{
				var game = this.parent as Game;
				var player = game.player as Player;
				
				if (((player.x > x) && (player.y > y) && ((player.x - x) > (player.y - y))) ||
					((player.x < x) && (player.y > y) && ((x - player.x) > (player.y - y))) ||
					((player.x > x) && (player.y < y) && ((player.x - x) > (y - player.y))) ||
					((player.x < x) && (player.y < y) && ((x - player.x) > (y - player.y))))
				{
					var snow = new SnowBall(this.x, this.y);
					this.parent.addChild(snow);
					this.parent.setChildIndex(snow, 2);
				}
			}
		}
	}
}