﻿/*
This class controls snow balls
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.media.*;
	
	public class SnowBall extends SnowMan
	{	
		public var speedX:int;
		public var speedY:int;
		
		public var flyTime:int;
		
		//the snowball is created in a Sledder's Attack() function 
		public function SnowBall(x_, y_)
		{	
			super(x_,y_)
			
			var targetX:int = Game.main.player.x;
			var targetY:int = Game.main.player.y;
			
			var dx:int;
			var dy:int;
			var dz:int;
			var fx:Number;
			var fy:Number;
			var rand:Number = Math.random()*2;
			if (Math.random() < .5)
				rand = rand * -1;
			
			dx = x - targetX;
			dy = y - targetY;
			dz = Math.sqrt(dx*dx + dy*dy)
			
			fx = (10*dx)/dz;
			fy = (10*dy)/dz;
			
			speedX = fx + rand;
			speedY = fy + rand;
			
			flyTime = 30;
			crashed = false;
		}
		
		public override function added(e:Event)
		{
			collider = new SnowManCollider();
		}
		
		//do this at frame rate
		public override function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{
				flyTime--;
				
				var i:int = parent.numChildren;

				while(i--)
				{
					var obj:DisplayObject = parent.getChildAt(i);
					if(this.hitTestObject(obj))
					{
						if ((obj is TreeCollider) || (obj is SlalomCollider))
						{
							crashed = true;
						}
						else if (((obj is SnowManCollider) || (obj is SnowBall)) && (obj != this))
						{ 
							crashed = true;
							
							var k:int = parent.numChildren;
								while (k--)
								{
									var that2:DisplayObject = parent.getChildAt(k);
									if ((that2.x == obj.x) && (that2.y == obj.y) && (that2 is SnowMan))
									{
										var thatSnowMan = that2 as SnowMan;
										thatSnowMan.hit();
									}
								}
						}
					}
				}
				
				move();
				
				if (flyTime <= 0 || crashed)
				{
					impactChannel = impact.play();
					var explode = new SnowBallExplode();
					parent.addChild(explode);
					explode.x = this.x;
					explode.y = this.y;
					kill();
				}
			}
		}
		
		//called when the player hits this
		public override function hit()
		{
			if (this.parent != null)
			{
				if (!Game.main.muted) impactChannel = impact.play();
				var explode = new SnowBallExplode();
				parent.addChild(explode);
				explode.x = this.x;
				explode.y = this.y;
				kill();
			}
		}
		
		public override function move()
		{
			if (this.parent != null)
			{
				y -= speedY;
				x -= speedX;

				if (y < -10 || y > Game.HEIGHT + 10 || x < -10 || x > Game.WIDTH + 10)
				{
					kill();
				}
			}
		}
	}
}