﻿/*
This class controls snowmen
*/

package
{

	import flash.display.*
	import flash.events.*
	import flash.ui.*
	import flash.filters.*
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.media.*;
	
	public class SnowMan extends Killable
	{		
		public var impact:Impact = new Impact();
		public var impactChannel:SoundChannel = new SoundChannel();
	
		public var crashed:Boolean;
		
		public var collider;
		
		//the snowman is created in the Game's PlaceSnowmen() function 
		public function SnowMan(x_, y_)
		{	
			crashed = false;
			
			//set the position of the snowman
			x = x_;
			y = y_;
			
			//add an ENTER_FRAME event so we can do some logic at frame rate
			addEventListener(Event.ENTER_FRAME, enterFrame);
			
			this.addEventListener(Event.ADDED_TO_STAGE, added);
		}
		
		public function added(e:Event)
		{
			collider = new SnowManCollider();
			collider.x = x;
			collider.y = y;
			collider.visible = false;
			parent.addChild(collider);
		}
		
		//do this at frame rate
		public function enterFrame(e:Event)
		{
			if ((this.parent != null) && (!Game.frozen))
			{
				move();
				
				if (y < -40)
				{
					kill();
				}
			}
		}
		
		public override function kill()
		{
			if (this.parent != null)
			{
				if (collider.parent != null) parent.removeChild(collider);
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				parent.removeChild(this);
			}
		}
		
		//called when the player hits this
		public function hit()
		{
			if ((this.parent != null) && !crashed)
			{
				play();
				if (!Game.main.muted) impactChannel = impact.play();
				crashed = true;
				if (collider.parent != null) parent.removeChild(collider);
			}
		}
		
		//if the player is not crashed, move up
		public function move()
		{
			if (Game.main.player.moving)
			{
				y -= 10;
				if (collider.parent != null) collider.y -= 10;
			}
		}
	}
}